proc dmonitor {{bus session}} {
    global dbusdata
    package require dbus
    if {[info exists dbusdata($bus)]} return
    set dbusdata($bus) ""
    set dbus [dbus connect $bus]
    dbus filter $dbus add -interface com.tclcode.tcltest -type signal
    dbus monitor $dbus [list apply [list {bus info args} {
	global dbusdata
	set dbusdata($bus) [dict replace $info args $args]
    }] $bus]
    # Close the dbus when testing is done
    tcltest::oncleanup [list apply [list {bus dbus} {
	global dbusdata
	dbus close $dbus
	dbus unset -nocomplain dbusdata($bus)
    }]]
    # Ignore the NameAcquired signal when connecting
    dbusdata $bus
    return
}

proc dbusdata {{bus session} {timeout 200}} {
    global dbusdata
    set id [after $timeout [list set dbusdata($bus) ""]]
    vwait dbusdata($bus)
    after cancel $id
    return $dbusdata($bus)
}

proc dbusargs {{bus session} {timeout 200}} {
    set data [dbusdata]
    if {[dict exists $data args]} {
	return [dict get $data args]
    }
}

proc tcltest::cleanupTestsHook {} {
    variable cleanup
    foreach cmd [lappend cleanup] {
	catch {uplevel #0 $cmd}
    }
    set cleanup {}
}

proc tcltest::oncleanup {cmd} {
    variable cleanup
    lappend cleanup $cmd
}
